﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.Primitives;
using Telerik.WinControls.UI;

namespace LargeDocumentDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.StartPosition = FormStartPosition.CenterScreen;
            this.Size = new Size(400, 400);

            Panel document = new Panel();
            document.AutoScroll = true;

            document.Dock = DockStyle.Fill;

            document.BackColor = Color.White;
            this.Controls.Add(document);
            this.Padding = new Padding(5);

            //very large RadButton
            RadButton btn = new RadButton();
            btn.BackColor = Color.Red;
            ((FillPrimitive) btn.ButtonElement.ButtonFillElement).GradientStyle =
                Telerik.WinControls.GradientStyles.Solid;

            btn.Width = 10;
            //btn.Dock = DockStyle.Left;
            btn.Bounds = new Rectangle(0, 0, 20, 50000);
            document.Controls.Add(btn);

            //very large winforms Button
            Button winForms = new Button();
            winForms.BackColor = Color.Yellow;
            ((FillPrimitive)btn.ButtonElement.ButtonFillElement).GradientStyle =
                Telerik.WinControls.GradientStyles.Solid;

            winForms.Bounds = new Rectangle(20, 0, 20, 50000);
            document.Controls.Add(winForms);

            for (int i = 0; i < 100; i++)
            {
                RadPanel radPanel = new RadPanel();
                radPanel.BackColor = Color.AliceBlue;
                radPanel.Padding = new Padding(5);
                radPanel.Bounds = new Rectangle(50, i * (50000 / 100), 400, 300);

                RadButton radButton = new RadButton();
                radButton.ThemeName = "ControlDefault";
                radButton.Bounds = new Rectangle(10, 50, 150, 40);
                radButton.Text = "Click to bind grid No " + (i + 1);
                radPanel.Controls.Add(radButton);

                RadLabel radLabel = new RadLabel();
                radLabel.Location = new Point(10, 10);
                radLabel.Text = "Panel location " + radPanel.Location;
                radPanel.Controls.Add(radLabel);

                RadGridView radGridView = new RadGridView();
                radGridView.ThemeName = "ControlDefault";
                radGridView.Height = 195;
                radGridView.Dock = DockStyle.Bottom;

                radButton.Click +=
                    delegate
                    {
                        BindingList<Color> sampleData =
                            new BindingList<Color>(new Color[] { Color.Red, Color.Blue, Color.Green });
                        radGridView.DataSource = sampleData;
                    };

                radPanel.Controls.Add(radGridView);

                document.Controls.Add(radPanel);
            }
        }
    }
}
